# Token Listing

{% hint style="info" %}
Tokenlists is a specification for lists of token metadata (e.g. address, decimals, etc.) that can be used by any dApp interfaces that needs one or more lists of tokens. Anyone can create and maintain a token list, as long as they follow the specification. The Pangolin community invites you to add your token to our tokenlist!
{% endhint %}

## Adding Your Token to Pangolin's List

### Adding Your Token

1. Add an entry in [Pangolin's tokenlist](https://github.com/pangolindex/tokenlists/blob/main/pangolin.tokenlist.json). Please use the [checksum address](https://docs.ethers.io/v5/api/utils/address/#address). Here is an example using PNG:

   <pre class="language-json" data-line-numbers><code class="lang-json">{
     "chainId": 43114,
     "address": "0x60781C2586D68229fde47564546784ab3fACA982",
     "decimals": 18,
     "name": "Pangolin",
     "symbol": "PNG",
     "logoURI": "https://raw.githubusercontent.com/pangolindex/tokens/main/assets/43114/0x60781C2586D68229fde47564546784ab3fACA982/logo.png"
   }
   </code></pre>
2. Update the `timestamp` field to the current timestamp.
3. Update the `version` field to adhere to semantic versioning:
   * Increment major version when tokens are removed.
   * Increment minor version when tokens are added.
   * Increment patch version when tokens already on the list have minor details changed (name, symbol, logo URL, decimals).

{% hint style="warning" %}
***Note:*** Changing a token address or chain ID is considered both a remove and an add, and should be a major version update.
{% endhint %}

### Add Token Logo

1. Create a new directory named using your [checksum token address](https://web3js.readthedocs.io/en/v1.7.1/web3-utils.html#tochecksumaddress).
2. Add your 24x24 token image as a file named `logo.png` inside the directory.
3. Add your 48x48 token image as a file named `logo_48.png` inside the directory.
4. No image should be larger than 10 KB.
5. Make sure the token is verified on the explorer.
6. Create a PR titled `Add [TOKEN_NAME]` to the `main` branch.

#### Example directory structures

```
├─ tokens/
└─┬─ assets/
  └─┬─[chain_id]/
    │
    ├─┬─ 0x60781C2586D68229fde47564546784ab3fACA982/
    │ ├── logo.png
    │ └── logo_48.png
    │
    ├─┬─ 0xB31f66AA3C1e785363F0875A1B74E27b85FD66c7/
    │ ├── logo.png
    │ └── logo_48.png
    │
 ...
```

{% hint style="success" %}

### Disclaimer

Pangolin allows anyone to submit new assets to this repository. However, this does not mean that Pangolin is in direct partnership with any project.

Pangolin will reject projects that are deemed as a scam or fraudulent after review. Pangolin reserves the right to change the terms of asset submissions at any time due to changing market conditions, risk of fraud, or any other factors we deem relevant.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pangolin.exchange/developers/token-listing.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
